        SUBROUTINE j6DRIV(IFUNC,RBUF,NBUF,CHR,LCHR)
c postscript in hp work_mode.
        REAL      RBUF(*)
        CHARACTER*16 CHR
	integer  LCHR
	byte buf(934400)
        common /jiangd/buf
        GOTO( 10, 20, 30, 40, 50, 60, 70,999, 90,100,
     &       110,120,130,140,150,999,999,180) IFUNC
        GOTO 999
C--- IFUNC= 1, Return device name.
10      CHR='J600PS'
	LCHR=LEN(CHR)
        RETURN
C--- IFUNC= 2, Return Physical min and max for plot device.
20      RBUF(1)=0
        RBUF(2)=2303                    !
        RBUF(3)=0
        RBUF(4)=3179                    !
        RBUF(5)=0
        RBUF(6)=1
        NBUF=6
        RETURN
C--- IFUNC= 3, Return device (X and Y) resolution in pixels per inch as
30      RBUF(1)=300.0
        RBUF(2)=300.0
        RBUF(3)=1
        NBUF=3
        LCHR=LEN(CHR)
        RETURN
C--- IFUNC= 4, Return misc device info.
40      CHR='HNNNNNNNNN'
        LCHR=10
        RETURN
C--- IFUNC= 5, Return default file name.
50      CHR='pgplot.j6'
        LCHR=LEN(CHR)
        RETURN
C--- IFUNC= 6, Return default physical size of plot.
60      RBUF(1)=0
        RBUF(2)=2303                    !
        RBUF(3)=0
        RBUF(4)=3179                    !
        RETURN
C--- IFUNC= 7, Return misc defaults.
70      RBUF(1)=1
        NBUF=1
        RETURN
C--- IFUNC= 9, Open workstation.
90      CALL grglun(lun)
        OPEN(UNIT=lun,FILE=CHR(:LCHR),STATUS='NEW',IOSTAT=IER)
        IF(IER.NE.0) THEN
            CALL GRWARN('Cannot open graphics device '//CHR(:LCHR))
            RBUF(1)=lun
            RBUF(2)=0
	    close (lun)
		goto 999
        ELSE
            RBUF(1)=0
            RBUF(2)=1
        END IF
        RETURN
C--- IFUNC=10, Close workstation.
100	close (lun)
        RETURN
C--- IFUNC=11, Begin Picture.  Note, IXMIN=0 and IXMAX=RBUF(1) so,
C--- IXDIM=IXMAX-IXMIN+1=RBUF(1)+1
110     IxDIM=INT(RBUF(1)/8.)+1  
        IyDIM=RBUF(2)+1           
        LENBUF=IxDIM*IyDIM
        call grjp02(buf,lenbuf)
        RETURN
C--- IFUNC=12, Draw line.
120     CALL GRjp01(1,RBUF,ICOL,IxDIM,buf)
        RETURN
C--- IFUNC=13, Draw dot.
130     CALL GRjp01(0,RBUF,ICOL,IxDIM,buf)
        RETURN
C--- IFUNC=14, End picture.
140     CALL GRj604(LUN,buf,IxDIM,IyDIM)
        RETURN
C--- IFUNC=15, Select pen.  Save pen number (up to 11) for
C--- possible use in pattern interior.
150     ICOL=MAX(0,MIN(NINT(RBUF(1)),11))
        RBUF(1)=MAX(0,MIN(ICOL,1))
        RETURN
c      for gray scale raster
180	call grjp03(rbuf,ixdim,buf)
	return
C--- Flag function not implemented.
999     NBUF=-1
        RETURN
        END

        SUBROUTINE GRj604(LUN,map,IXDIM,IYDIM)
c map(72,3180), iydim=3180
        integer map(ixdim/4,iydim),c(4)
	character*594 line
	byte bl(594)
	equivalence (line,bl)
	write(lun,1)
1	format('%! Jiang_ps map_dump'/'erasepage initgraphics'/
     *  '[-1 0 0 -1 4700 6500] setmatrix'/'0 0 translate'/
     *  '2 2 scale'/
     *  '/r_data 16 string def'/'/r_zero 16 string def'/
     *  '/r_full 16 string def'/'/r_bkg1 16 string def'/
     *  'currentfile r_full readhexstring ',32('F')/
     *  'currentfile r_bkg1 readhexstring ',32('2')/
     *  'clear'/'/dline {0 exch translate 2304 1 true matrix'/
     *  '{currentfile read pop dup 97 eq'/
     *  '{pop currentfile r_data readhexstring pop}'/
     *  '{dup 98 eq'/'{pop r_zero}'/'{dup 99 eq'/'{pop r_full}'/
     *  '{100 eq'/'{r_bkg1}'/'ifelse}'/'ifelse}'/'ifelse}'/
     *  'ifelse'/'}imagemask} def')
	call decswap(map,ixdim*iydim/4)      ! for DECstation
	ll=0
	do 10 l=1,iydim
	k=0
	m=1
	do 20 j=1,18
	ip=0
	do 30 i=1,4
	k=k+1
	c(i)=map(k,l)
30	if(c(i).ne.0.and.c(i).ne.-1)ip=1
	if(ip.ne.0)then
	write(line(m:),"('a',4z8.8)")c
	do 40 mm=m+1,m+32
40	if(bl(mm).gt.80)bl(mm)=bl(mm)-32
	m=m+33
	else
	if(c(1).eq.0)line(m:m)='b'
	if(c(1).eq.-1)line(m:m)='c'
	m=m+1
	endif
20	continue
	if(line(1:18).eq.'bbbbbbbbbbbbbbbbbb')then
	ll=ll+1
	else
	k=1
	if(ll.gt.9)k=2
	if(ll.gt.99)k=3
	if(ll.gt.999)k=4
c	write(lun,'(i<k>," dline"/a)')ll,line(1:m-1)
	if(k.eq.1)write(lun,'(i1," dline"/a)')ll,line(1:m-1)
	if(k.eq.2)write(lun,'(i2," dline"/a)')ll,line(1:m-1)
	if(k.eq.3)write(lun,'(i3," dline"/a)')ll,line(1:m-1)
	if(k.eq.4)write(lun,'(i4," dline"/a)')ll,line(1:m-1)
	ll=1
	endif
10	continue
	write(lun,'("showpage")')
	end
